-- Notifications und Triggers
SET ANSI_NULLS ON
SET QUOTED_IDENTIFIER ON
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[Notification](
	[System] [varchar](50) NOT NULL,
	[ID] [int] NOT NULL,
	[Name] [varchar](250) NOT NULL,
	[Active] [bit] NOT NULL,
 CONSTRAINT [PK_Notification] PRIMARY KEY CLUSTERED 
(
	[System] ASC,
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
CREATE TABLE [dbo].[Trigger](
	[System] [varchar](50) NOT NULL,
	[Parent] [int] NOT NULL,
	[Sensor] [int] NOT NULL,
	[ID] [int] NOT NULL,
	[TriggerType] [varchar](20) NOT NULL,
	[Notification] [int] NULL,
	[Escalation] [int] NULL,
	[Clearing] [int] NULL,
	[Source] [int] NOT NULL,
	[Condition] [varchar](250) NULL,
	[ValidUntil] [datetime] NOT NULL,
 CONSTRAINT [PK_Triggers] PRIMARY KEY CLUSTERED 
(
	[System] ASC,
	[Parent] ASC,
	[Sensor] ASC,
	[ID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
ALTER TABLE [dbo].[Notification]  WITH CHECK ADD  CONSTRAINT [FK_Notification_System] FOREIGN KEY([System])
REFERENCES [dbo].[System] ([ID])
ALTER TABLE [dbo].[Notification] CHECK CONSTRAINT [FK_Notification_System]
GO
ALTER TABLE [dbo].[Trigger]  WITH CHECK ADD  CONSTRAINT [FK_Trigger_Notification] FOREIGN KEY([System], [Notification])
REFERENCES [dbo].[Notification] ([System], [ID])
ALTER TABLE [dbo].[Trigger] CHECK CONSTRAINT [FK_Trigger_Notification]
ALTER TABLE [dbo].[Trigger]  WITH CHECK ADD  CONSTRAINT [FK_Trigger_Notification1] FOREIGN KEY([System], [Escalation])
REFERENCES [dbo].[Notification] ([System], [ID])
ALTER TABLE [dbo].[Trigger] CHECK CONSTRAINT [FK_Trigger_Notification1]
ALTER TABLE [dbo].[Trigger]  WITH CHECK ADD  CONSTRAINT [FK_Trigger_Notification2] FOREIGN KEY([System], [Clearing])
REFERENCES [dbo].[Notification] ([System], [ID])
ALTER TABLE [dbo].[Trigger] CHECK CONSTRAINT [FK_Trigger_Notification2]
ALTER TABLE [dbo].[Trigger]  WITH CHECK ADD  CONSTRAINT [FK_Trigger_Sensor] FOREIGN KEY([System], [Sensor])
REFERENCES [dbo].[Sensor] ([System], [ID])
ALTER TABLE [dbo].[Trigger] CHECK CONSTRAINT [FK_Trigger_Sensor]
ALTER TABLE [dbo].[Trigger]  WITH CHECK ADD  CONSTRAINT [FK_Trigger_System] FOREIGN KEY([System])
REFERENCES [dbo].[System] ([ID])
ALTER TABLE [dbo].[Trigger] CHECK CONSTRAINT [FK_Trigger_System]
GO
INSERT INTO [dbo].[Constants] ([table],[column],[id],[text])
SELECT 'Trigger','Source',0,'Self'
UNION ALL SELECT 'Trigger','Source',1,'Parent'
UNION ALL SELECT 'Trigger','Source',2,'Library'
GO
INSERT INTO [dbo].[Changelog] ([Version], [changes]) VALUES (2, 'Added Notifications und Triggers')